require 'faraday'
require 'faraday_middleware'
require 'her'
require "securevideo/api/version"
require "securevideo/api/time_zones"
require "securevideo/api/response"
module Securevideo
  module Api
    class ClientNotConfigured < Exception; end
    class << self
      def configure(api_key, secret_key, &block)
        @api = Her::API.new
        @api.setup :url => "https://api.securevideo.com" do |c|
          c.basic_auth(api_key, secret_key)
          c.use FaradayMiddleware::EncodeJson
          c.use Her::Middleware::AcceptJSON
          c.use Her::Middleware::FirstLevelParseJSON
          yield c if block_given?
          c.adapter :excon
        end
        require "securevideo/api/user"
        require "securevideo/api/session"
        require "securevideo/api/participant"
      end

      def api
        # raise exception if somehow model classes gets required
        # before the API is configured
        fail ClientNotConfigured.new('Securevideo') unless @api
        @api
      end
    end

  end
end
SKEY = '8364943fde7842d38095adcfa0244eca20a9a3a1089a40d3b55f96dc88990118'
SSECRET = '2a6a362d0e4a48e184afdecaa0794ef5365ba2aab79f49d18d4c544421ed7945'
Securevideo::Api.configure(SKEY, SSECRET)

# q.TimeZoneWindowsId = "Pacific Standard Time"
# q.EmailAddress = 'max-pechnikov@yandex.ru'
# q.HelpNumber = '4084062331'
